Version 2.7.6
---------------------------
- improved renderer responsiveness while recursive search #315
- added custom request params to the "downloadItem" action #318
- enhanced .Net Core Framework connector #316 #319
- added capability to set custom client configuration file path #329
- prevented caching language files #332
- updated PHP connector dependency to v1.2.6
(https://github.com/servocoder/RichFilemanager-PHP/releases/tag/v1.2.6)


Version 2.7.5
---------------------------
- bugfix: server-side errors haven't shown on upload #305
- datetime types received from server extended to: seconds, milliseconds and datetime string #308
- updated PHP connector dependency to v1.2.4
(https://github.com/servocoder/RichFilemanager-PHP/releases/tag/v1.2.4)


Version 2.7.4
---------------------------
- fixed CodeMirror lib missed file #301
- updated CodeMirror package to v5.35.0
- updated PHP connector dependency to v1.2.3
(https://github.com/servocoder/RichFilemanager-PHP/releases/tag/v1.2.3)


Version 2.7.3
---------------------------
- hotfix


Version 2.7.2
---------------------------
- added optional connector "options.capabilities" in the initiate action #272
- avoid loading right panel folder contents when unfolding tree if click on +(plus) icon #293
- included resourceObject to "selectItem" callback #294
- minified and combined assets with new grunt config #295
- implemented customizable upload parameter name #297
- updated russian translations (minor fixes) #292
- updated dutch translations
- updated PHP connector dependency to v1.2.2
(https://github.com/servocoder/RichFilemanager-PHP/releases/tag/v1.2.2)

Backward incompatible changes:
- restructure and refactor source package files and third-party libs


Version 2.7.1
---------------------------
- implemented RFM plugin public methods "refreshFolder" and "loadFolder" #275
- bugfix: problem with folder downloading #273
- bigfix: redirect on failed authentication doesn't work #278
- bugfix: fileroot issue with symbolic links #285
- updated PHP connector dependency to v1.2.1
(https://github.com/servocoder/RichFilemanager-PHP/releases/tag/v1.2.1)


Version 2.7.0
---------------------------
- server-side search implemented, relative to the open folder #271
- implemented client-side datetime formatting using globalizejs and cldrjs #227
- added "createFolder" capability in JSON config file (affects appropriate UI elements visibility) #227
- adjusted language codes and UI lang files names #227
- added new translations into language files #269 #271
- changed behavior of the "close" button of preview mode; made it more straightforward, respecting search mode
- PHP connector: implemented events and listeners (as callback functions) for API operations #236 servocoder/RichFilemanager#24
- PHP connector: throw an error if delete operation failed servocoder/RichFilemanager#29
- PHP connector: allow double underscores in file names servocoder/RichFilemanager#28
- PHP connector: automatically exclude image thumbnails folder from the output servocoder/RichFilemanager#27
- PHP connector: avoid spaces and parentheses inserted into a file name while upload #112 servocoder/RichFilemanager#26
- PHP connector: use a single point to calculate filesize across application servocoder/RichFilemanager#25
- JAVA connector: actualized to the latest API version and support all features; moved to separate repository
- bugfix: fixed missed "home" breadcrumbs icon on after RFM initiated
- bugfix: PHP connector local storage always return "false" when deleting file servocoder/RichFilemanager#29

Backward incompatible changes:
- API: error response format altered to correspond to JSON API standard #210 servocoder/RichFilemanager#30
- API: new error handling flow; required HTTP headers; strict JSON API conformity #270 servocoder/RichFilemanager#33
- API: simplified workflow of the "download" method, doesn't require AJAX API extra call anymore #248 #265 servocoder/RichFilemanager#32
- API: "getfile" API method RENAMED to "getinfo" and return either file or folder stats. Restriction to handle files only is removed #270
- API: "getfolder" API method RENAMED to "readfolder". No changes in functionality #270
- API: "readfile", "getimage" and "download" methods USE THE SAME FLOW to read file content and write it to the output #270
- API: "editfile" method is REMOVED, instead of it the "readfile" is used at the client #270
- API: "seekfolder" new method is ADDED #271 servocoder/RichFilemanager#34
- API file and folder object response structure: removed "timestamp" attribute; "created" and "modified" attributes now contain unix timestamps instead of formatted datetime strings #227
- "options.searchBox" configuration option is removed, new section "search" added instead #271


Version 2.6.5
---------------------------
- tightened dependencies between "richfilemanager-php" and main packages #268
- JAVA connector: replaced "title" with "message" in error response format #231
- bugfix: broken modal window in CKEditor integration when open "table" tool #263
- Vietnamese language: updated translations #267
- Czech language: updated translations


Version 2.6.4
---------------------------
- reworked folder loader for filetree and right panel #255
- implemented "beforeSetRequestParams" and "beforeSendRequest" callback functions #260
- bugfix: should close folder in right panel upon delete its ancestor n filetree #261
- added template for GitHub issues
- better file renderers support


Version 2.6.3
---------------------------
- improvement: direct upload upon simple file uploads #247
- bugfix: when delete opened folder from filetree the right panel should switch to the parent folder #252
- Spanish language: updated translations #253


Version 2.6.2
---------------------------
- implemented progress bar for batch operations #249
- bugfix: type filters do not work with the list view #225 #228
- Java connector: added file type check before uploading files #245
- Chinese (Taiwan) language: updated translations #240
- Persian (Farsi) language: added lang file #250 #251
- Arabic language: complete rewrite #230
- Portuguese language: updated translations


Version 2.6.1 (Hotfix)
---------------------------
- better compression with uglifyJs
- bugfix: broken references in the minified RFM script
- bugfix: no images previews in the grid/list when using filters along with images lazyLoad feature


Version 2.6.0
---------------------------
- implemented language switcher with page reload #171
- implemented client-side filtering with UI buttons #204
- added predefined filters in the config file for client-side filtering, thanks @Saso222 #205
- updated NodeJs connector: new response format, support for most API methods, thanks @forestlake #209
- updates and customizations for LazyLoad plugin to support IE9 & IE10 #214
- added refresh folder items / item preview UI button #215
- clipboard UI buttons are disabled when no actions are available #220
- rearranged header UI buttons
- updated DE translations
- updated ZN-CN translations, thanks @toolgood #208
- bugfix: wrong URL docs.google.com viewer, thanks @abnerjacobsen #213
- bugfix: Lazy Loading for thumbs doesn't work for new/moved/copied images #214
- bugfix: selected files are not taken properly when using the copy button in the toolbar #219

Backward incompatible changes:
- "options.culture" configuration option is moved to "language.default" option
- "options.defaultViewMode" configuration option is moved to "manager.defaultView" option
- removed obsolete "showFullPath" and "localizeGUI" configuration options #216
- removed "flat-oil" and "flat-turquoise" themes


Version 2.5.1
---------------------------
- added capability to pass parameters to the connector, thanks @Saso222 #132
- lazyload images thumbnails in the right panel, thanks @gmkll #148
- updated JSP connector, compatible with v2.5.x, thanks @gmkll #195
- bugfix: mouse scrolling doesn't work for default browser scroll


Version 2.5.0
---------------------------
- Asp.Net Core connector support, thanks @sinanbozkus #163;
- Python 3 Flask connector support, thanks @jsooter #164;
- added redirect functionality if initial authorization fails #183;
- added possibility to copy URLs without flash (Zeroclipboard replaced with clipboard.js library) #150;
- added new `clipboard`.`encodeCopyUrl` configuration option #191;
- fixed "initiate" method of ASHX connector #194;
- updated Italian translations #183;
- updated Czech translations;

Backward incompatible changes:
- `clipboard` configuration option was moved out of `options` section and became a separate section;


Version 2.4.0
---------------------------
- New backend security model #111;
- PHP connector: general refactoring #90, #109, #111;
- PHP connector: removed "actions_list" definition, replaced with "readOnly" option #134, #143;
- API: removed "extension" response attribute, fetched from filename at the client-side now #106;
- New iframe viewer to preview html files #177;
- Editor is configured as independent component, compatible with iframe viewer #177;
- bugfix: (PHP connector) "download" API action requires the folder to be writable #130;

Backward incompatible changes:
- removed "replace" API action;
- PHP connector moved to the separate repository - should be installed via composer;
- removed referrer HTTP parameters parsing ("type" particularly) and "images only" check in the uploader;
- removed "allowNoExtension" configuration option, now it depends on "extensions" server-side configuration option;
- `allowFolderDownload` configuration option moved to the client-side JSON file, doesn't depend on server-side anymore;
- `viewer`.`editable` configuration option is moved out of `viewer` section and renamed to `editor`;


Version 2.3.3
---------------------------
- bugfix: incorrect displaying of items extracted from archive;
- bugfix: (S3 storage) configured ACL doesn't apply #152;
- bugfix: (S3 storage) error upon renaming folders which includes subfolders #168;
- bugfix: (S3 storage) video doesn't playback on preview #169;
- bugfix: clipboard copy / cut doesn't work on filetree items #170;


Version 2.3.2
---------------------------
- implement "extract" action to unzip archives #22;
- removed duplicated configuration options (common for both client and server sides) #109;
- new isolated way to handle server-side errors;
- bugfix: wrong scroll behavior in IE #151;
- bugfix: error when copying to a folder with spaces #153;
- bugfix: not loading userfiles folder when it's empty #154;

Backward incompatible changes:
- server-side language files specific for a particular connector should be removed;
- new format for server-side errors: label + arguments to be treated with JSON lang files;
- `security`.`allowFolderDownload` server-side configuration option moved to `options` section;
- removed the following server-side configuration options (see details in #109):
	* `overrideClientConfig` (since no duplicated options now);
	* `options`.`culture` (since no translations at the server side now);
	* `security`.`allowChangeExtensions` (no affect security, clint-side only now);
	* `upload`.`paramName` (no sense to change value for this option);
	* `upload`.`chunkSize` (client-side solely option);
- reduced a list of parameters in "initiate" server-side action;


Version 2.3.1
---------------------------
- extended drag and drop: ability to drag items between panels (tree <-> view) #133;
- improved items behavior on draggable and selectable actions;
- improved view items rendering performance;
- bugfix: wrong unselect behavior for selected items;
- bugfix: wrong position of "parent" item in case "folderPosition" options is set to "top" #143;


Version 2.3.0
---------------------------
- Java connector (Spring MVC) support, thanks @fabriceci #126;
- Support Markdown files side-by-side interactive editing, thanks @dereks #88;
- Custom renderers support. CodeMirror and MarkdownIt are implemented #85;
- Capability to render index file content in folder listing mode (similar to what GitHub does) #88;
- Capability to preview renderable files right after opening;
- Support Java lang in renderer / editor preview #118;
- PHP connector: added capability to define logfile path #123;
- bugfix: remove "time" query parameter upon file selection #116;
- bugfix: unable to retrieve absolute path, even when "previewUrl" is specified #116;
- bugfix: issues while copying file URL; better preview mode support #120
- bugfix: folder isn't loaded when opened from filetree and preview mode is enabled #120;
- bugfix: logger configuration doesn't take effect in PHP connector #123;
- bugfix: wrong position of "parent" item in IE #124;


Version 2.2.2
---------------------------
- new section "filetree" in configuration file;
- independent ajax calls for filetree and fileview #103, #104;
- selectable supports custom scrollbar (scrolling + selection);
- bugfix: missed custom scrollbar for preview mode;
- bugfix: bugfix: breadcrumbs is broken if "exclusiveFolder" is set #107;
- bugfix: close button issue on integration with CKEditor #108;


Version 2.2.1
---------------------------
- breadcrumbs instead of string for the current path #96;
- improved determining of active context during "select" action;
- implemented postMessage communication capability on "select" action;
- demo page new examples: simple js window, fancybox iframe, tinyMCE 4 iframe;
- updated translations in [el] and [fr] language files;
- bugfix: scrollbar issues #98;
- bugfix: sorting in list view doesn't work #97;
- bugfix: file and folder info isn't updated after the file has been modified #95;
- bugfix: (PHP connector) images uploads are failed in case "imagesOnly" configuration option is enabled #74;


Version 2.2.0
---------------------------
- clipboard feature: copy, cut, paste, clear (header panel and context menu) #80;
- implemented "copy" action at the client-side and PHP connector (see API) to support clipboard copy feature;
- configurable clipboard availability via `clipboard` option in json configuration file;
- implemented context menu on items background; include clipboard "paste" and "create folder" items;
- more flexible permissions control: attribute "protected" has been split into two: readable and writable attributes #91, #92;
- support [.md] markdown files editing out of the box #86;
- create new and adjust existing translations;
- better support of define RFM context for "select" action;
- bugfix: error on filtering inside a subfolder #89;
- bugfix: error upon setup default theme for CodeMirror #86;
- bugfix: text editor remains open after close preview #79;
- bugfix: corrupted PHP S3 plugin move/copy of thumbnails if located at AWS S3 storage;
- included "purl" library to parse urls and updated CodeMirror library;

Backward incompatible changes:
- API: attribute "protected" has been split into two: readable and writable attributes #91, #92;


Version 2.1.0
---------------------------
- implemented selectable view items (mouse dragging & Ctrl key), see `manager`.`selection` config options #15, #38;
- implemented multiple actions for selected items (move, delete, download) #11, #15, #38;
- special drag helper while dragging multiple items:
	* shows number items items;
	* prevents on moving (to) protect folder or to the one of selected items;
- provided an ability to open files/folders with mouse dblClick, see `manager`.`dblClickOpen` config option;
- improved injection of dynamic assets (js & css) with toast plugin;
- added "afterSelectItem" callback function #73;
- created file to initiate RFM plugin and configure with callbacks and baseUrl #73;
- "select" action now available without window.opener to use RFM inside custom modal windows (bootstrap, jquery dialog, etc.);
- bugfix: scrollbar not showing on initial load #77;
- PHP connector: bugfix comma in filename problem #78;
- composer is added to the project #71;

Backward incompatible changes:
- JSON configuration file "filemanager.config.default.json" has been moved from "/scripts" to "/config" folder;
- have to copy and rename "/config/filemanager.init.js.example" file, along with JSON configuration file;


Version 2.0.3
---------------------------
- added "overrideClientConfig" option in PHP connector config file, "false" by default
- added callback functions for some urls modification, described in Wiki article "Configuration"
- moved application plugin initialization to the index file
- adjusted Wiki articles and ReadMe.md file
- bugfix: broken "exclusiveFolder" query param


Version 2.0.2
---------------------------
- ASHX connector is up-to-date (thanks @richeflits)
- bugfix: displaying file type in list view


Version 2.0.1
---------------------------
- new demo site: http://fm.devale.pro
- bugfix: broken "expandedFolder" query param (#59)
- bugfix: download action for files less than 16mb (#60)
- removed "filter_output" method from "getfile" action (PHP)


Version 2.0.0
---------------------------
- js file reworked to become a plugin
- some ajax async calls replaced with deferred chains (based on #21)
- new nice notifications, based on alertify plugin on my fork (#25)
- theme concept was reworked, base assets created, no need to duplicate all assets for new theme
- started with demo page with examples for different usage cases
- many changes in html templates to make thing more organaized
- upload popup dialog now scrollable
- migrated frontend to knockout.js
- removed a number of the application plugins (tinysort, filetree, impromptu, liveSearch); their functionality has been replaced with own implementation
- grid view icons implemented via css styles (#47)
- capability to preview images and media files with absolute path along with connector path (#27, #31)
- completely rewritten and standardized Rich Filemanager API that follows JSON API best practices (#37)
- configuration splitted into two files: server and client config files (#31, #32)
- implemented "initiate" request to provide ability to override client-side configuration options (#29, #32)
- refactored client-side configuration files: deleted obsolete options, some options or sections were moved/renamed (actual configuration description is in WIKI)
- implemented actions-based access management (#24)
- greatly improved security for PHP connector, a number of vulnerabilities were fixed
- handle large files download in PHP connector (#56)
- "languages" folder moved to the root FM folder


Version 1.0.6
---------------------------
- removed `fileConnector` option from server-side;
- removed 'Preview' and 'Thumbnail' params from `getinfo` response;
- all preview paths (images, media, office files) are now associated to connector. Absolute paths for icons exclusively;
- all preview paths are now built at the client-side (connector independent) for better API support;
- added support of seeking for media files in PHP connector (including S3 storage plugin);
- added capability to pass custom configuration options in filemanager.php to override the default config;
- PHP connector refactored, following OOP practices;
- added icons for OpenOffice files;


Version 1.0.5
---------------------------
- Added a capability to preview images and media files when the userfiles folder is located beyond server root directory
- Improved path processing at the client-side. Absolute path used whenever it is possible. Normalization of the preview path
- Improved a way of automatically determination of `baseUrl` based on page URL
- Fixed bug: Copy URL to clipboard does not work - #5
- Fixed bug: Path issue upon file selection in WYSIWYG editor
- Fixed bug: It is possible to select folders in WYSIWYG editor
- Fixed bug: Preview of media and pdf files is broken when the path contains special chars (fixed by path encoding)


Version 1.0.4
---------------------------
- Improved and extended logging process
- Added new associations of some icons with file types for filetree and listview (docx, xlsx, odt, ods, odp, etc...)
- Fixed bug: multiple issues when filemanager is located and accessible not from root (nested) folder
- Fixed bug: error in PHP connector while file downloading
- Fixed bug: error in PHP connector while transliteration process


Version 1.0.0
---------------------------
- Drag & Drop feature
- Updated third-party libraries and plugins
- Implemented plugins system for PHP connector (server-based)
- Implemented AWS S3 storage plugin
- Ability to limit max size of the storage (root folder)
- Optimized for integration with frameworks - added "pluginPath" option to load scripts correctly when using custom path routing
- Extended list of previewed file types via ViewerJS
- Implemented preview of MS Office file types via Google Docs Viewer
- Dropzone file uploader replaced with Blueimp's jQuery-File-Upload, which provides out of the box following features:
    * chunked upload;
    * image resizing (Wideimage lib was removed);
    * image orientation (auto-rotation);
- New design and features in multiple upload window for preview items; controls for each item (start, abort, resume, delete, etc.)
- Improved Filetree: allow to open and display multiple subfolders at a time
- Improved manipulation of Filetree nodes:
    * rewritten most of items manipulation methods to perform all possible operations on client-side;
    * this made possible to significantly reduce number of server requests (which is critical for S3 servers that charge you for each request);
    * implemented "moveNode" for Drag & Drop and "replace" action;
- Implemented "moveNode" for Drag & Drop and "replace" action
- Added new "Type" column in the list view
- Implemented natural sorting on the client-side for Filetree nodes and Fileinfo items after "upload", "add", "rename", "move" and other actions
- Improved list view sorting: sort settings are persistent during folders navigation and not reset as it was before
- Caching result of some requests which were duplicated for Filetree and Fileinfo sections (like "getfolder")
- Reduced number of requests to server by implementing "getFolderData" method that caches data for a short time
- Rewritten most of items manipulation methods to perform all possible operations on client-side, that makes possible
to significantly reduce number of server requests (which is critical for S3 servers that charge you for each request)
- FM template wrapped with ".fm-container" container; CSS rules in all themes were encapsulated to affect only elements inside container
- New transliteration methods on client and server sides (PHP) to support a wide range of chars (cyrillic, chinese, etc.)
- Auto calculating FM height when place it to the non-empty page to fill the empty space (between header and footer, for example)
- Improved FM height calculating (check required for CKEditor and other WYSIWYGs)
- Fixed bug: security vulnerabilities in PHP connector ("getinfo", "rename" and "move" methods)
- Fixed bug: "Parent Folder" button in file preview mode works correctly
- Fixed bug: sorting respects type of item (file/folder) and doesn't mixes them together
- Fixed bug: handle download errors correctly, if any
- Fixed bug: better error handling for client-size and in PHP connector